package com.example.demo_fingerprint_fips.fragment;

import android.os.Bundle;

import androidx.fragment.app.Fragment;

import android.os.Handler;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.AdapterView;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

import com.example.demo_fingerprint_fips.FileUtils;
import com.example.demo_fingerprint_fips.MainActivity;
import com.example.demo_fingerprint_fips.R;
import com.rscja.deviceapi.FingerprintWithFIPS;
import com.rscja.utility.StringUtility;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;


public class ImportFragment extends Fragment implements View.OnClickListener {
    private MainActivity mContext;
    private static final String TAG = "ImportFragment";
    private Button btnImport;

    private ListView lsTemplate;

    private TextView tvTip;
    private TextView tvInfoMsg;
    ScrollView scroll2;
    private HashMap<String, String> hashMap;


    private String path;
    private Handler handler = new Handler();

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container,
                             Bundle savedInstanceState) {
        Log.i(TAG, "onCreateView()");
        View v = inflater.inflate(R.layout.fragment_import,
                container, false);
        return v;
    }

    @Override
    public void onActivityCreated(Bundle savedInstanceState) {
        super.onActivityCreated(savedInstanceState);
        mContext = (MainActivity) getActivity();
        init();
    }

    @Override
    public void onPause() {
        Log.d(TAG, "onPause");
        super.onPause();
    }

    @Override
    public void onResume() {
        super.onResume();
        Log.d(TAG, "onResume");
    }


    private void init() {
        tvTip = (TextView) getView().findViewById(R.id.tvTip);
        tvInfoMsg = (TextView) getView().findViewById(R.id.tvInfoMsg);
        btnImport = (Button) getView().findViewById(R.id.btnImport);

        scroll2 = (ScrollView) getView().findViewById(R.id.scroll2);
        lsTemplate = (ListView) getView().findViewById(R.id.lsTemplate);

        btnImport.setOnClickListener(this);
        tvTip.setText(FileUtils.PATH);
        lsTemplate.setVerticalScrollBarEnabled(true);
        initListTemplate();

        lsTemplate.setOnItemClickListener(new AdapterView.OnItemClickListener() {
            @Override
            public void onItemClick(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
                //获得选中项的HashMap对象
                String key = (String) lsTemplate.getItemAtPosition(arg2);
                path = hashMap.get(key);
            }
        });
    }

    private void initListTemplate() {
        hashMap = FileUtils.ReadFileName();
        if(hashMap==null)
            return;

        List<String> data = new ArrayList<String>();
        Iterator iter = hashMap.entrySet().iterator();
        while (iter.hasNext()) {
            Map.Entry entry = (Map.Entry) iter.next();
            Object key = entry.getKey();
            data.add(key.toString());
        }
        ArrayAdapter<String> adapter = new ArrayAdapter<String>(getActivity(), R.layout.listitem, R.id.list_item, data);
        lsTemplate.setAdapter(adapter);
    }


    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.btnImport:
                if (!mContext.isPower) {
                    Toast.makeText(mContext, "The fingerprints did not run on!", Toast.LENGTH_SHORT).show();
                    return;
                }
                if (path == null || path.length() < 0)
                    return;
                String temp = FileUtils.ReadFile(path);
                if (!temp.isEmpty()) {
                    byte[] templateData = StringUtility.hexStringToBytes(temp);
                    int fingerprintID = mContext.mFingerprint.storeFinger(templateData);
                    if (fingerprintID>=0) {
                        tvInfoMsg.setText("success  fingerprintID:"+fingerprintID);
                    } else {
                        tvInfoMsg.setText("fail");
                    }
                }
                break;
        }
    }
}